/***********************************************/
/*      ASTEROID 850@                         */
/*      ver 1.00A                              */
/*      +GAME LIB                              */
/*      ver 1.00                               */
/*      2006-11 Choi Kyun                      */
/***********************************************/



#ifdef GLOBAL_VALUE_DEFINE
#define GLOBAL
#define GLOBAL_VAL(v) = (v)
#else
#define GLOBAL extern
#define GLOBAL_VAL(v)
#endif



/************************************************
	錾
************************************************/
// @
typedef struct
{
  byte direc;	// 
  int x;	// XW
  int y;	// YW
  int add_x;	// Xx
  int add_y;	// Yx
  byte energy;	// GlM[
} SHIPS;

// e
typedef struct
{
  byte x;	// XW
  byte y;	// YW
  char add_x;	// Xړl
  char add_y;	// Yړl
} SHOTS;

// GlM[pbN
typedef struct
{
  byte flg;	// \tO
  byte x;
  byte y;
  char add_x;
  char add_y;
} ENERGYS;

// AXeCh
typedef struct
{
  byte flg;	// 
  byte speed;	// Xs[h
  byte speed_def;
  int x;	// XW
  int y;	// YW
  int add_x;	// Xx
  int add_y;	// Yx
} ASTEROIDS;

// UFO
typedef struct
{
  byte flg;	// \tO
  byte step;	// ړ]JEg
  byte x;
  byte y;
  char add_x;
  char add_y;
} UFOS;



/************************************************
	萔
************************************************/
// Q[[h
#define MODE_TITLE 0
#define MODE_INIT 1
#define MODE_RUN 2
#define MODE_BASIC 3

// @l
#define DEF_SHIP_WAIT 8
#define DEF_SHIP_DIREC 2
#define DEF_SHIP_X 60*256
#define DEF_SHIP_Y 36*256

// GlM[
#define DEF_ENERGY 64
#define DEF_ENE_WAIT 10
#define DEF_RECOVERY 16

// e
#define DEF_SHOOT_WAIT 12
#define DEF_SHOT_WAIT 3
#define SHOT_MAX 2

// AXeCh
#define DEF_A_SPEED 16
#define MAX_AST 16

#define A_LARGE 16
#define A_MIDDLE 10
#define A_SMALL 6

// UFO
#define DEF_UFO_WAIT 4
#define DEF_UFO_STEP 12

// ACR
#define DEF_ICON_X 137+16
#define DEF_ICON_Y 7



/************************************************
	O[oϐ
************************************************/
// Q[[h
GLOBAL byte game_mode;

// @f[^
GLOBAL SHIPS ship;

// GlM[pbN
GLOBAL ENERGYS epac;

// ef[^
GLOBAL SHOTS shot[2];
// eJEg
GLOBAL byte shot_cnt;

// AXeCh
GLOBAL ASTEROIDS ast[MAX_AST];	//ő16
// AXeCh JEg
GLOBAL byte ast_cnt;

// UFO
GLOBAL UFOS ufo;

// XRA
GLOBAL word sc, hisc;



/************************************************
	vg^Cv
************************************************/
// main.c



#undef GLOBAL
#undef GLOBAL_VAL
