/*********************************/
/*      PC-G850 GAME LIBRALY     */
/*            ver 1.01           */
/*         2006 CHOI KYUN        */
/*    kyuns@lily.freemail.ne.jp  */
/*********************************/



#ifdef GLOBAL_VALUE_DEFINE
#define GLOBAL
#define GLOBAL_VAL(v) = (v)
#else
#define GLOBAL extern
#define GLOBAL_VAL(v)
#endif



// ^
typedef unsigned char byte;
typedef unsigned int word;
typedef unsigned char bool;



/************************************************
	萔
************************************************/
#define TRUE 1
#define FALSE 0

#define ON 1
#define OFF 0

#define SCREEN_WIDTH 256
#define SCREEN_HEIGHT 10
#define SCREEN_BLANK 16		// E̗]~Ƃ

#define WIN_WIDTH 96


/* L[R[h */
#define KEY_CLS 128
#define KEY_SPC 64
#define KEY_6 32
#define KEY_2 16
#define KEY_4 8
#define KEY_8 4
#define KEY_SHIFT 1



/************************************************
	O[oϐ
************************************************/
// obt@
GLOBAL byte screen[ SCREEN_WIDTH * SCREEN_HEIGHT ];

// L[
GLOBAL byte key;
GLOBAL byte keyf;

// _
GLOBAL word rand_seed;

// BEEP
GLOBAL byte sound;



/************************************************
	vg^Cv
************************************************/
void cls( void );				// ʃNA hnbrgp
void inKey( byte *, byte * );			// L[
void dispScreenBuff( byte, byte, byte * );	// XN[\
void drawBitMap( byte, byte, byte, byte *, byte * );// rbg}bv\
void clearFullScreenBuff( byte * );		// XN[NA
void clearWindow( byte, byte * );		// XN[NA 
void drawCharacter( byte, byte, byte *, byte * );// LN^[`
void init_LCD( void );				// kbc
void init_BEEP( void );				// addo
void beep( byte, word, word );			// addo
void randomize( void );				// _}CY
byte rnd( void );				// _
bool checkBreakKey( void );			// aqd`jL[o
void sys_putChar( byte, byte, byte );		// hnbr 1\
void *sys_putString( byte, byte, byte, byte * );// hnbr \
void sys_putCharN( byte, byte, byte, byte );	// hnbr ꕶA\
void sys_drawBitMap( byte, byte, byte, byte * );// hnbrrbg}bv\
bool sys_inkey1( byte * );			// hnbr L[
bool sys_inkey2( byte * );			// hnbr L[2



#undef GLOBAL
#undef GLOBAL_VAL
