	.area _CODE


;	L[
;	void	inKey( byte *key, byte *keyf )
_inKey::
	ld	iy,#2
	add	iy,sp

	ld	c,0(iy)		;KEY
	ld	b,1(iy)

	ld	e,2(iy)		;KEYF
	ld	d,3(iy)

	ld	a,(bc)
	cpl
	ld	(de),a


	ld	a,#0b00001000	;[SPC]
	out	(#0x011),a
	xor	a
	out	(#0x012),a	;L[Xg[uo

	call	__keywait	;L[EFCg

	in	a,(#0x010)	;L[R
	and	#0b00100000	;[SPC]
	rlca			;b6=[SPC]
	ld	l,a

	ld	a,#0b00100000	;[2]
	out	(#0x011),a
	xor	a
	out	(#0x012),a	;L[Xg[uo

	call	__keywait

	in	a,(#0x010)	;L[R
	and	#0b00010000	;[2]
	or	l		;b4=[2]
	ld	l,a

	ld	a,#0b10000000	;[8]
	out	(#0x011),a
	xor	a
	out	(#0x012),a	;L[Xg[uo

	call	__keywait

	in	a,(#0x010)	;L[R
	and	#0b00010000	;[8]
	rrca
	rrca
	or	l
	ld	l,a		;b2=[8]

	ld	a,#0b01000000	;[4],[6]
	out	(#0x011),a
	xor	a
	out	(#0x012),a	;L[Xg[uo

	call	__keywait

	in	a,(#0x010)	;L[R
	and	#0b00101000	;[4],[6]
	or	l		;b3=[4] b5=[6]
	ld	l,a

	xor	a
	out	(#0x011),a
	ld	a,#0b00000010	;[CLS]
	out	(#0x012),a	;L[Xg[uo

	call	__keywait

	in	a,(#0x010)	;L[R
	and	#0b10000000	;b7=[CLS]
	or	l
	ld	l,a

	ld	a,#0b00001000	;[SHIFT]
	out	(#0x011),a
	xor	a
	out	(#0x012),a	;L[Xg[uo

	call	__keywait

	in	a,(#0x013)	;[SHIFT]
	and	#0b00000001
	or	l		;b0=[SHIFT]
	ld	l,a

	ld	(bc),a

	ld	a,(de)
	and	l		;(keyf) & (key)
	ld	(de),a
	ret



	;L[EFCg@K
__keywait:
	push	bc
	ld	bc,#2
10$:
		dec	bc
		ld	a,c
		or	b
		jr	nz,10$
	pop	bc
	ret



;	BREAKL[`FbN
;	bool	checkBreakKey( void )
_checkBreakKey::
	ld	l,#0
	in	a,(#0x01f)
	rlca
	jr	c,10$
	ret
10$:
	inc	l
	ret



	